package test.wsdl.jaxrpchandler2;

import javax.xml.namespace.QName;
import javax.xml.rpc.handler.Handler;
import javax.xml.rpc.handler.HandlerInfo;
import javax.xml.rpc.handler.MessageContext;
import javax.xml.rpc.handler.soap.SOAPMessageContext;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPBodyElement;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;

public class EchoServiceServerHandler implements Handler {

    public boolean handleRequest(MessageContext messageContext) {

	try {
	    SOAPMessageContext soapMsgCtx = (SOAPMessageContext) messageContext;
	    
	    SOAPMessage soapMsg = soapMsgCtx.getMessage();
	    SOAPPart soapPart = soapMsg.getSOAPPart();
	    SOAPEnvelope soapEnvelope = soapPart.getEnvelope();
	    soapEnvelope.getBody().detachNode();
	    SOAPBody soapBody = soapEnvelope.addBody();
	    SOAPBodyElement echoElement = soapBody.addBodyElement(soapEnvelope.createName("echo", "ns1", "http://soapinterop.org/"));
	    SOAPElement argElement = echoElement.addChildElement("arg0");
	    argElement = argElement.addAttribute(soapEnvelope.createName("type", "xsi", "http://www.w3.org/2001/XMLSchema-instance"), "xsd:string");
	    argElement.addTextNode("my echo string");
	    soapMsg.saveChanges();
	    
	} catch (Exception e) {
	    e.printStackTrace();
	}
	
	return true;
    }
    
    public boolean handleResponse(MessageContext messageContext) {
	return true;
    }

    
    public boolean handleFault(MessageContext messageContext) {
	return true;
    }

    public void init(HandlerInfo arg0) {
    }

    public void destroy() {
    }

    public QName[] getHeaders() {
	return null;
    }
    
}
